## mariadb-10.0 10.0.14

=== storage/tokudb/CMakeLists.txt ===
# ft-index only supports x86-64 and cmake-2.8.9+
IF(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" AND
    NOT CMAKE_VERSION VERSION_LESS "2.8.9")
CHECK_CXX_SOURCE_COMPILES(
"
struct a {int b; int c; };
struct a d = { .b=1, .c=2 };
int main() { return 0; }
" TOKUDB_OK)
ENDIF()

IF(NOT TOKUDB_OK OR WITHOUT_TOKUDB OR WITHOUT_TOKUDB_STORAGE_ENGINE)
  RETURN()
ENDIF()

IF(NOT LIBJEMALLOC)
  MESSAGE(WARNING "TokuDB is enabled, but jemalloc is not. This configuration is not supported")
ENDIF()

############################################
SET(TOKUDB_VERSION "7.1.8")
SET(TOKUDB_DEB_FILES "usr/lib/mysql/plugin/ha_tokudb.so\netc/mysql/conf.d/tokudb.cnf\nusr/bin/tokuftdump\nusr/share/doc/mariadb-server-10.0/README-TOKUDB\nusr/share/doc/mariadb-server-10.0/README.md" PARENT_SCOPE)
SET(USE_BDB OFF CACHE BOOL "")
MARK_AS_ADVANCED(BUILDNAME)
MARK_AS_ADVANCED(BUILD_TESTING)
MARK_AS_ADVANCED(CMAKE_TOKUDB_REVISION)
MARK_AS_ADVANCED(LIBTOKUDB)
MARK_AS_ADVANCED(LIBTOKUPORTABILITY)
MARK_AS_ADVANCED(TOKUDB_DATA)
MARK_AS_ADVANCED(TOKU_DEBUG_PARANOID)
MARK_AS_ADVANCED(USE_BDB)
MARK_AS_ADVANCED(USE_VALGRIND)
MARK_AS_ADVANCED(XZ_SOURCE_DIR)
############################################

SET(BUILD_TESTING OFF CACHE BOOL "")
SET(USE_VALGRIND OFF CACHE BOOL "")
SET(TOKU_DEBUG_PARANOID OFF CACHE BOOL "")

IF(NOT DEFINED TOKUDB_VERSION)
    IF(DEFINED ENV{TOKUDB_VERSION})
        SET(TOKUDB_VERSION $ENV{TOKUDB_VERSION})
    ENDIF()
ENDIF()
IF(DEFINED TOKUDB_VERSION)
    ADD_DEFINITIONS("-DTOKUDB_VERSION=\"${TOKUDB_VERSION}\"")
ENDIF()

IF(DEFINED TOKUDB_NOPATCH_CONFIG)
    ADD_DEFINITIONS("-DTOKUDB_NOPATCH_CONFIG=${TOKUDB_NOPATCH_CONFIG}")
ENDIF()

IF(DEFINED TOKUDB_CHECK_JEMALLOC)
    ADD_DEFINITIONS("-DTOKUDB_CHECK_JEMALLOC=${TOKUDB_CHECK_JEMALLOC}")
ENDIF()

## adds a compiler flag if the compiler supports it
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

macro(set_cflags_if_supported)
  foreach(flag ${ARGN})
    check_c_compiler_flag(${flag} HAVE_C_${flag})
    if (HAVE_C_${flag})
      set(CMAKE_C_FLAGS "${flag} ${CMAKE_C_FLAGS}")
    endif ()
    check_cxx_compiler_flag(${flag} HAVE_CXX_${flag})
    if (HAVE_CXX_${flag})
      set(CMAKE_CXX_FLAGS "${flag} ${CMAKE_CXX_FLAGS}")
    endif ()
  endforeach(flag)
endmacro(set_cflags_if_supported)

set_cflags_if_supported(-Wno-missing-field-initializers)

ADD_SUBDIRECTORY(ft-index)

INCLUDE_DIRECTORIES(ft-index)
INCLUDE_DIRECTORIES(ft-index/portability)
INCLUDE_DIRECTORIES(ft-index/util)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/ft-index)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/ft-index/buildheader)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/ft-index/portability)

SET(TOKUDB_PLUGIN_DYNAMIC "ha_tokudb")
SET(TOKUDB_SOURCES ha_tokudb.cc)
MYSQL_ADD_PLUGIN(tokudb ${TOKUDB_SOURCES} STORAGE_ENGINE MODULE_ONLY
    LINK_LIBRARIES tokufractaltree_static tokuportability_static ${ZLIB_LIBRARY} stdc++)
SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} -flto -fuse-linker-plugin")
SET(CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO} -flto -fuse-linker-plugin")

SET(CPACK_RPM_server_PACKAGE_OBSOLETES
  "${CPACK_RPM_server_PACKAGE_OBSOLETES} MariaDB-tokudb-engine < 10.0.5" PARENT_SCOPE)

IF (INSTALL_SYSCONF2DIR)
  INSTALL(FILES tokudb.cnf DESTINATION ${INSTALL_SYSCONF2DIR} COMPONENT Server)
ENDIF(INSTALL_SYSCONF2DIR)

=== debian/changelog ===
mariadb-10.0 (10.0.14-4) unstable; urgency=low

  * Updated patch d/username-in-tests-replace.patch to fix the
    obfuscation done by anti-spam measures in the MariaDB
    commit message view (Closes: #769865).
  * Unified indentantion to two spaces in init file for easier
    debugging of #609537

 -- Otto Kekäläinen <otto@seravo.fi> Mon, 17 Nov 2014 11:45:11 +0200

mariadb-10.0 (10.0.14-3) unstable; urgency=low

  * Added patch d/username-in-tests-replace.patch to fix
    test failure (Closes: #769212).
  * Added versioned dependency on libpcre3 (Closes: #767903).

 -- Otto Kekäläinen <otto@seravo.fi>  Wed, 12 Nov 2014 15:00:11 +0300

mariadb-10.0 (10.0.14-2) unstable; urgency=low

  [ Tobias Frost ]
  * Fix two lintian warnings in d/copyright (missing "-" between GPL and 2)
  * Always be verbose when building the package and show compiler args

  [ Otto Kekäläinen ]
  * Upload to unstable
  * Updated German translation by Chris Leick and Holger Wansing
    (Closes: #763952)
  * Updated Dutch translation by Frans Spiesschaert (Closes: #764013)
  * Removed libssl-dev from build dependencies in favour of using
    bundled YaSSL instead (Closes: #761911)
  * Fixed debconf value saving (Closes: #761452)
  * Re-enabled TokuDB after backporting upstream fix in MDEV-6815
  * Removed libmariadbclient packages that provided the Debian-only
    libmariadbclient.so library that nobody used. Instead developers are
    encouraged to use the libraries from the package libmariadb-client-lgpl
    instead (Closes: #739452) (Closes: #742172).

 -- Otto Kekäläinen <otto@seravo.fi>  Sat, 18 Oct 2014 19:00:11 +0300

mariadb-10.0 (10.0.14-1) experimental; urgency=low

  * New upstream release. (Closes: #757026)
  * d/control: Removed Provides: libmysqlclient-dev (Closes: #759309)
  * d/control: Removed Provides: libmysqld-dev with same motivation
  * Updated Swedish translation by Martin Bagge
    and Anders Jonsson (Closes: #762795)
  * Updated Spanish translation by Javier Fernandez-Sanguino (Closes: #762751)
  * Updated Portugese translation by Miguel Figueiredo (Closes: #763194)
  * Updated Czech translation by Miroslav Kure (Closes: #763309)

 -- Otto Kekäläinen <otto@seravo.fi>  Thu, 28 Aug 2014 00:39:02 +0300

mariadb-10.0 (10.0.10-1) experimental; urgency=low

  * Initial Upload (Closes: #740473)

 -- Otto Kekäläinen <otto@seravo.fi>  Tue, 01 Apr 2014 09:56:38 +0300

=== debian/control ===
Source: mariadb-10.0
Section: database
Priority: optional
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@seravo.fi>, Arnaud Fontaine <arnau@debian.org>
Build-Depends: bison,
               chrpath,
               cmake,
               debhelper (>= 9),
               dh-apparmor,
               libaio-dev [linux-any],
               libboost-dev,
               libjemalloc-dev [linux-any],
               libjudy-dev,
               libncurses5-dev (>= 5.0-6~),
               libpam0g-dev,
               libpcre3-dev (>= 1:8.35),
               libreadline-gplv2-dev,
               libwrap0-dev (>= 7.6-8.3~),
               lsb-release,
               perl,
               po-debconf,
               psmisc,
               zlib1g-dev (>= 1:1.1.3-5~)
Standards-Version: 3.9.6
Homepage: http://mariadb.org/
Vcs-Git: git://anonscm.debian.org/pkg-mysql/mariadb-10.0.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-mysql/mariadb-10.0.git

Package: libmariadbd-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libmysqld-dev
Replaces: libmysqld-dev
Description: MariaDB embedded database development files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the embedded server library and header files.

Package: mariadb-common
Architecture: all
Depends: mysql-common, ${misc:Depends}
Multi-Arch: foreign
Description: MariaDB common metapackage
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This empty metapackage makes the introduction on MariaDB specific
 configurationfiles easier at any later time.

Package: mariadb-client-core-10.0
Architecture: any
Depends: mariadb-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: mysql-client-5.5, mysql-client-5.6
Breaks: mariadb-client-core-5.5,
        mysql-client-core-5.5,
        mysql-client-core-5.6,
        virtual-mysql-client-core
Replaces: mariadb-client-core-5.5,
          mysql-client-core-5.5,
          mysql-client-core-5.6,
          virtual-mysql-client-core
Provides: virtual-mysql-client-core
Description: MariaDB database core client binaries
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the core client files, as used by Akonadi.

Package: mariadb-client-10.0
Architecture: any
Depends: debianutils (>=1.6),
         libdbi-perl,
         libterm-readkey-perl,
         mariadb-client-core-10.0 (>= ${source:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: libdbd-mysql-perl (>= 1.2202)
Conflicts: mysql-client-core-5.5, mysql-client-core-5.6
Breaks: mariadb-client-5.5,
        mysql-client,
        mysql-client-5.5,
        mysql-client-5.6,
        virtual-mysql-client
Replaces: mariadb-client-5.5,
          mysql-client,
          mysql-client-5.5,
          mysql-client-5.6,
          virtual-mysql-client
Provides: virtual-mysql-client
Description: MariaDB database client binaries
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the client binaries and the additional tools
 innotop and mysqlreport.

Package: mariadb-server-core-10.0
Architecture: any
Depends: mariadb-common, ${misc:Depends}, ${shlibs:Depends}
Conflicts: mariadb-galera-server-5.5, mysql-server-5.5, mysql-server-5.6
Breaks: mariadb-server-core-5.5,
        mysql-server-core-5.5,
        mysql-server-core-5.6,
        virtual-mysql-server-core
Replaces: mariadb-server-core-5.5,
          mysql-server-core-5.5,
          mysql-server-core-5.6,
          virtual-mysql-server-core
Provides: virtual-mysql-server-core
Description: MariaDB database core server files
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the core server files, as used by Akonadi.

Package: mariadb-test-10.0
Architecture: any
Depends: mariadb-client-10.0 (>= ${source:Version}),
         mariadb-server-10.0 (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: mariadb-test (<< ${source:Version}),
        mariadb-test-5.5,
        mysql-testsuite,
        mysql-testsuite-5.5,
        mysql-testsuite-5.6,
        virtual-mysql-testsuite
Replaces: mariadb-test (<< ${source:Version}),
          mariadb-test-5.5,
          mysql-testsuite,
          mysql-testsuite-5.5,
          mysql-testsuite-5.6,
          virtual-mysql-testsuite
Provides: virtual-mysql-testsuite
Suggests: patch
Description: MariaDB database regression test suite
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the regression test suite.

Package: mariadb-server-10.0
Architecture: any
Suggests: mailx, mariadb-test, tinyca
Recommends: libhtml-template-perl
Pre-Depends: adduser (>= 3.40), debconf, mariadb-common
Depends: libdbi-perl,
         lsb-base (>= 3.0-10),
         mariadb-client-10.0 (>= ${source:Version}),
         mariadb-server-core-10.0 (>= ${binary:Version}),
         passwd,
         perl (>= 5.6),
         psmisc,
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: mariadb-tokudb-engine-10.0,
           mariadb-tokudb-engine-5.5,
           mysql-server-core-5.5,
           mysql-server-core-5.6
Breaks: mariadb-galera-server,
        mariadb-galera-server-5.5,
        mariadb-server-5.5,
        mariadb-tokudb-engine-10.0,
        mariadb-tokudb-engine-5.5,
        mysql-server,
        mysql-server-5.5,
        mysql-server-5.6,
        virtual-mysql-server
Replaces: mariadb-galera-server,
          mariadb-galera-server-5.5,
          mariadb-server-5.5,
          mariadb-tokudb-engine-10.0,
          mariadb-tokudb-engine-5.5,
          mysql-server,
          mysql-server-5.5,
          mysql-server-5.6,
          virtual-mysql-server
Provides: virtual-mysql-server
Description: MariaDB database server binaries
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.
 .
 This package includes the server binaries.

Package: mariadb-server
Architecture: all
Depends: mariadb-server-10.0 (>= ${source:Version}), ${misc:Depends}
Description: MariaDB database server (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mariadb-server (currently mariadb-server-10.0), as determined by the MariaDB
 maintainers. Install this package if in doubt about which MariaDB
 version you need. That will install the version recommended by the
 package maintainers.
 .
 MariaDB is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MariaDB are speed, robustness and
 ease of use.

Package: mariadb-client
Architecture: all
Depends: mariadb-client-10.0 (>= ${source:Version}), ${misc:Depends}
Description: MariaDB database client (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mariadb-client (currently mariadb-client-10.0), as determined by the MariaDB
 maintainers.  Install this package if in doubt about which MariaDB version
 you want, as this is the one considered to be in the best shape.

Package: mariadb-test
Architecture: all
Depends: mariadb-test-10.0 (>= ${source:Version}), ${misc:Depends}
Description: MariaDB database regression test suite (metapackage for the latest version)
 This is an empty package that depends on the current "best" version of
 mariadb-test (currently mariadb-test-10.0), as determined by the MariaDB
 maintainers.

Package: mariadb-connect-engine-10.0
Architecture: any
Depends: libxml2,
         mariadb-server-10.0|mariadb-galera-server-10.0,
         unixodbc,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Connect storage engine for MariaDB
 Connect engine supports a number of file formats (dbf, xml, txt, bin, etc),
 connections to ODBC tables and remote MySQL tables, as well as a number of
 other interesting features.
 This package contains the Connect plugin for MariaDB.

Package: mariadb-oqgraph-engine-10.0
Architecture: any
Depends: libjudydebian1,
         mariadb-server-10.0|mariadb-galera-server-10.0,
         ${misc:Depends},
         ${shlibs:Depends}
Description: OQGraph storage engine for MariaDB
 The OQGraph engine is a computation engine plugin for handling hierarchies
 (trees) and graphs (friend-of-a-friend, etc) cleanly through standard SQL.
 This package contains the OQGraph plugin for MariaDB.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
# Used in mysql-5.6, might be needed here too but not added
# until some confimation is found
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

TMP:=$(CURDIR)/debian/tmp/

ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEBVERSION := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed 's/^.*-//' )

ifneq (,$(filter $(ARCH), i386 kfreebsd-i386 hurd-i386))
    TAOCRYPT_OPT="-DTAOCRYPT_DISABLE_X86ASM"
endif

# Skip TokuDB if arch is not amd64
ifneq ($(ARCH), amd64)
    TOKUDB_OPT:=-DWITHOUT_TOKUDB=true
endif

export MYSQL_BUILD_CC=$(DEB_HOST_GNU_TYPE)-gcc
export MYSQL_BUILD_CXX=$(DEB_HOST_GNU_TYPE)-g++

DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_UPSTREAM_VERSION_MAJOR_MINOR := $(shell echo $(DEB_UPSTREAM_VERSION) | sed -r -n 's/^([0-9]+\.[0-9]+).*/\1/p')
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DISTRIBUTION := $(shell lsb_release -i -s)
RELEASE := $(shell lsb_release -r -s)

# Parallel build support as adviced
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    # Placeholder code to implement max cpu count value checking
    # if [$(NUMJOBS) > $(shell if [ -f /proc/cpuinfo ] ; then grep -c processor.* /proc/cpuinfo ; else echo 1 ; fi)]
    #  then NUMJOBS = 0
    # fi
    MAKEFLAGS += -j $(NUMJOBS)
endif

# Add support for verbose builds
MAKEFLAGS += VERBOSE=1

MAKE_TEST_TARGET:=test-force
ifneq ($(findstring fulltest,$(DEB_BUILD_OPTIONS)),)
# make test-bt is the testsuite run by the MySQL build team
# before a release, but it is long
    MAKE_TEST_TARGET:=test-bt
endif

USE_ASSEMBLER:=--enable-assembler

ifneq (,$(filter $(ARCH), amd64 kfreebsd-amd64 i386 kfreebsd-i386 ia64 s390 s390x))
    TESTSUITE_FAIL_CMD:=exit 1
else
    TESTSUITE_FAIL_CMD:=true
endif

BUILDDIR := builddir
builddir = $(BUILDDIR)

# This causes seg11 crashes if LDAP is used for groups in /etc/nsswitch.conf
# so it is disabled by default although, according to MySQL, it brings >10%
# performance gain if enabled. See #299382.
ifeq ($(STATIC_MYSQLD), 1)
    USE_STATIC_MYSQLD:=--with-mysqld-ldflags=-all-static
endif

override_dh_auto_clean:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	[ ! -d mysql-test/var ] || rm -rf mysql-test/var
	rm -rf $(BUILDDIR)
	debconf-updatepo # Update po-files when clean runs before each build

override_dh_prep:
        # Don't clean /tmp/ away, it is needed by all binary packages

override_dh_auto_configure:
	@echo "RULES.$@"
	dh_testdir
	
	( test -d $(builddir) || mkdir $(builddir) ) && cd $(builddir) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/usr/local/bin:/usr/bin:/bin"} \
	    	CC=$${MYSQL_BUILD_CC:-gcc} \
		CFLAGS=$${MYSQL_BUILD_CFLAGS:-"-O2 -DBIG_JOINS=1 -fno-strict-aliasing ${TAOCRYPT_OPT}"} \
	    	CXX=$${MYSQL_BUILD_CXX:-g++} \
	    	CXXFLAGS=$${MYSQL_BUILD_CXXFLAGS:-"-O3 -DBIG_JOINS=1 -felide-constructors -fno-exceptions -fno-rtti -fno-strict-aliasing ${TAOCRYPT_OPT}"} \
	    cmake -DCMAKE_INSTALL_PREFIX=/usr \
	    $(USE_STATIC_MYSQLD) \
	    -$(MAKEFLAGS) \
	    $(TOKUDB_OPT) \
	    -DWITH_SSL=bundled \
	    -DCOMPILATION_COMMENT="($(DISTRIBUTION))" \
	    -DMYSQL_SERVER_SUFFIX="-$(DEBVERSION)" \
	    -DSYSTEM_TYPE="debian-$(DEB_BUILD_GNU_SYSTEM)" \
	    -DBUILD_CONFIG=mysql_release \
	    -DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
	    -DINSTALL_PLUGINDIR=lib/mysql/plugin \
		-DDEB=1 ..'
	touch $@

# This is needed, otherwise 'make test' will run before binaries have been built
override_dh_auto_build:
	@echo "RULES.$@"
	cd $(builddir) && $(MAKE)
	touch $@

override_dh_auto_test:
	@echo "RULES.$@"
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd $(builddir) && $(MAKE) $(MAKE_TEST_TARGET) || $(TESTSUITE_FAIL_CMD) ;
endif

override_dh_auto_install:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	
	# If TokuDB plugin was built add it to the server install list.
	[ ! -f $(BUILDDIR)/usr/lib/mysql/plugin/ha_tokudb.so ] || echo 'usr/lib/mysql/plugin/ha_tokudb.so\netc/mysql/conf.d/tokudb.cnf\nusr/bin/tokuftdump\nusr/share/doc/mariadb-server-10.0/README-TOKUDB\nusr/share/doc/mariadb-server-10.0/README.md' >> debian/mariadb-server-10.0.install
	
	# If libthrift-dev was available (manually installed, as it is not in Debian)
	# and ha_cassandra.so was thus built add it to the server install list.
	[ ! -f $(BUILDDIR)/storage/cassandra/ha_cassandra.so ] || echo 'usr/lib/mysql/plugin/ha_cassandra.so' >> debian/mariadb-server-10.0.install
	
	mkdir -p $(TMP)/etc/mysql/conf.d/
	cp debian/additions/mysqld_safe_syslog.cnf $(TMP)/etc/mysql/conf.d/
	
	# make install (trailing slash needed for innobase)
	cd $(builddir) && $(MAKE) install DESTDIR=$(TMP)/
	
	# After installing, remove rpath to make lintian happy.
	set +e; \
	find ./debian/tmp/ -type f -print0 \
		| xargs -0 --no-run-if-empty chrpath -k 2>/dev/null \
		| fgrep RPATH= \
		| cut -d: -f 1 \
		| xargs --no-run-if-empty chrpath -d; \
	set -e
	
	# libmysqlclient-dev: forgotten header file since 3.23.25?
	cp $(BUILDDIR)/include/my_config.h $(TMP)/usr/include/mysql/
	cp include/my_dir.h $(TMP)/usr/include/mysql/
	
	# mariadb-common: MariaDB-specific config stuff.
	install -d $(TMP)/etc/mysql/conf.d
	install -m 0644 debian/additions/mariadb.cnf $(TMP)/etc/mysql/conf.d/mariadb.cnf
	
	# mariadb-server
	rm -vf $(TMP)/usr/share/mysql/mi_test_all* \
	       $(TMP)/usr/share/mysql/mysql-log-rotate \
	       $(TMP)/usr/share/mysql/mysql.server \
	       $(TMP)/usr/share/mysql/binary-configure
	nm -n $(BUILDDIR)/sql/mysqld |gzip -n -9 > $(TMP)/usr/share/doc/mariadb-server-10.0/mysqld.sym.gz
	# Below didn't work, use more explicit command above
	# nm -n $(BUILDDIR)/sql/mysqld |gzip -9 > debian/mysqld.sym.gz
	mkdir -p $(TMP)/etc/mysql/conf.d/
	install -m 0755 debian/additions/echo_stderr $(TMP)/usr/share/mysql/
	install -m 0755 debian/additions/debian-start $(TMP)/etc/mysql/
	install -m 0755 debian/additions/debian-start.inc.sh $(TMP)/usr/share/mysql/
	mkdir -p $(TMP)/usr/share/doc/mariadb-server-10.0
	install -m 0644 $(builddir)/Docs/INFO_SRC $(TMP)/usr/share/doc/mariadb-server-10.0/INFO_SRC
	install -m 0644 $(builddir)/Docs/INFO_BIN $(TMP)/usr/share/doc/mariadb-server-10.0/INFO_BIN
	
	# install AppArmor profile
	install -D -m 644 debian/apparmor-profile $(TMP)/etc/apparmor.d/usr.sbin.mysqld
	
	# install Apport hook
	install -D -m 644 debian/mariadb-server-10.0.py $(TMP)/usr/share/apport/package-hooks/source_mariadb-10.0.py
	
	# mariadb-test
	mv $(TMP)/usr/mysql-test $(TMP)/usr/share/mysql
	touch $@

override_dh_installlogrotate-arch:
	dh_installlogrotate --name mysql-server

# Start mysql in runlevel 19 before 20 where apache, proftpd etc gets
# started which might depend on a running database server.
override_dh_installinit-arch:
	dh_installinit --name=mysql -- defaults 19 21

override_dh_installcron-arch:
	dh_installcron --name mysql-server

%:
	dh $@ --parallel

# vim: ts=8
